// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/network_interface_apb_wrapper.hpp"



network_interface_apb_wrapper::network_interface_apb_wrapper() :
    pwdata_old(0UL),
    pwrite_old(false),
    penable_old(false),
    psel_old(false),
    paddr_old(0UL),
    presetn_old(false),
    pclk_old(false),
    hif_a2t_data(
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr),
    clk(false),
    reset(false),
    mode(false),
    rx_data_ready(false),
    rx_data(0UL),
    tx_data_ready(false),
    tx_data(0UL),
    tx_data_done(false),
    network_interface_0(),
    clk_new(false),
    reset_new(false),
    mode_new(false),
    rx_data_ready_new(false),
    rx_data_new(0UL),
    tx_data_ready_new(false),
    tx_data_new(0UL),
    tx_data_done_new(false),
    process_in_queue(false),
    flag_globact_process_11_executed(false),
    flag_pclk(false),
    flag_globact_process_12_executed(false),
    flag_presetn(false),
    flag_globact_process_13_executed(false),
    flag_pwrite(false),
    flag_rx_data_ready(false),
    flag_tx_data_done(false),
    flag_rx_data(false),
    flag_globact_process_16_executed(false),
    flag_penable(false),
    flag_globact_process_17_executed(false),
    flag_pwdata(false)
{
}


network_interface_apb_wrapper::~network_interface_apb_wrapper()
{}


void network_interface_apb_wrapper::perform_bindings()
{
    network_interface_0.hif_a2t_data.clk = &clk;
    network_interface_0.hif_a2t_data.reset = &reset;
    network_interface_0.hif_a2t_data.mode = &mode;
    network_interface_0.hif_a2t_data.rx_data_ready = &rx_data_ready_new;
    network_interface_0.hif_a2t_data.rx_data = &rx_data_new;
    network_interface_0.hif_a2t_data.tx_data_ready = &tx_data_ready;
    network_interface_0.hif_a2t_data.tx_data = &tx_data;
    network_interface_0.hif_a2t_data.tx_data_done = &tx_data_done_new;
}


void network_interface_apb_wrapper::globact_process_11()
{
    clk_new = *hif_a2t_data.pclk;
}


void network_interface_apb_wrapper::globact_process_12()
{
    reset_new = *hif_a2t_data.presetn;
}


void network_interface_apb_wrapper::globact_process_13()
{
    mode_new = *hif_a2t_data.pwrite;
}


void network_interface_apb_wrapper::globact_process_14()
{
    *hif_a2t_data.pready = rx_data_ready || tx_data_done;
}


void network_interface_apb_wrapper::globact_process_15()
{
    *hif_a2t_data.prdata = rx_data;
}


void network_interface_apb_wrapper::globact_process_16()
{
    tx_data_ready_new = *hif_a2t_data.penable;
}


void network_interface_apb_wrapper::globact_process_17()
{
    tx_data_new = *hif_a2t_data.pwdata;
}


void network_interface_apb_wrapper::update_input_queue( bool synch_phase )
{
    process_in_queue = false;
    if (*hif_a2t_data.pclk != pclk_old)
    {
        pclk_old = *hif_a2t_data.pclk;
        flag_pclk = true;
        process_in_queue = true;
    }
    else
    {
        flag_pclk = false;
    }
    if (*hif_a2t_data.presetn != presetn_old)
    {
        presetn_old = *hif_a2t_data.presetn;
        flag_presetn = true;
        process_in_queue = true;
    }
    else
    {
        flag_presetn = false;
    }
    paddr_old = *hif_a2t_data.paddr;
    psel_old = *hif_a2t_data.psel;
    if (*hif_a2t_data.penable != penable_old)
    {
        penable_old = *hif_a2t_data.penable;
        flag_penable = true;
        process_in_queue = true;
    }
    else
    {
        flag_penable = false;
    }
    if (*hif_a2t_data.pwrite != pwrite_old)
    {
        pwrite_old = *hif_a2t_data.pwrite;
        flag_pwrite = true;
        process_in_queue = true;
    }
    else
    {
        flag_pwrite = false;
    }
    if (*hif_a2t_data.pwdata != pwdata_old)
    {
        pwdata_old = *hif_a2t_data.pwdata;
        flag_pwdata = true;
        process_in_queue = true;
    }
    else
    {
        flag_pwdata = false;
    }
    if (synch_phase)
    {
        network_interface_0.update_input_queue( true );
        process_in_queue = process_in_queue || network_interface_0.process_in_queue;
    }
}


void network_interface_apb_wrapper::update_event_queue()
{
    process_in_queue = false;
    update_input_queue( false );
    clk = clk_new;
    mode = mode_new;
    reset = reset_new;
    if (rx_data != rx_data_new)
    {
        rx_data = rx_data_new;
        flag_rx_data = true;
        process_in_queue = true;
    }
    else
    {
        flag_rx_data = false;
    }
    if (rx_data_ready != rx_data_ready_new)
    {
        rx_data_ready = rx_data_ready_new;
        flag_rx_data_ready = true;
        process_in_queue = true;
    }
    else
    {
        flag_rx_data_ready = false;
    }
    tx_data = tx_data_new;
    if (tx_data_done != tx_data_done_new)
    {
        tx_data_done = tx_data_done_new;
        flag_tx_data_done = true;
        process_in_queue = true;
    }
    else
    {
        flag_tx_data_done = false;
    }
    tx_data_ready = tx_data_ready_new;
    network_interface_0.update_event_queue();
    process_in_queue = process_in_queue || network_interface_0.process_in_queue;
}


void network_interface_apb_wrapper::flag_elaboration()
{
    flag_globact_process_11_executed = false;
    if (flag_pclk)
    {
        globact_process_11();
        flag_globact_process_11_executed = true;
    }
    flag_globact_process_12_executed = false;
    if (flag_presetn)
    {
        globact_process_12();
        flag_globact_process_12_executed = true;
    }
    flag_globact_process_13_executed = false;
    if (flag_pwrite)
    {
        globact_process_13();
        flag_globact_process_13_executed = true;
    }
    if (flag_rx_data_ready || flag_tx_data_done)
    {
        globact_process_14();
    }
    if (flag_rx_data)
    {
        globact_process_15();
    }
    flag_globact_process_16_executed = false;
    if (flag_penable)
    {
        globact_process_16();
        flag_globact_process_16_executed = true;
    }
    flag_globact_process_17_executed = false;
    if (flag_pwdata)
    {
        globact_process_17();
        flag_globact_process_17_executed = true;
    }
    if (network_interface_0.process_in_queue)
    {
        network_interface_0.flag_elaboration();
    }
}


void network_interface_apb_wrapper::start_of_simulation()
{
    globact_process_11();
    flag_globact_process_11_executed = true;
    globact_process_12();
    flag_globact_process_12_executed = true;
    globact_process_13();
    flag_globact_process_13_executed = true;
    globact_process_14();
    globact_process_15();
    globact_process_16();
    flag_globact_process_16_executed = true;
    globact_process_17();
    flag_globact_process_17_executed = true;
}


void network_interface_apb_wrapper::initialize()
{
    start_of_simulation();
    network_interface_0.initialize();
}




